<?php

require_once TOROFLIX_DIR_PATH . 'admin/customizer/class-toroflix-multiple-checkbox.php';

function my_customize_register( $wp_customize ) {


    function theme_slug_sanitize_select( $input, $setting ){
        $input = sanitize_key($input);
        $choices = $setting->manager->get_control( $setting->id )->choices;
        return ( array_key_exists( $input, $choices ) ? $input : $setting->default );                   
    }

    function sanitize_multiple_checkbox( $values ) {
        $multi_values = ! is_array( $values ) ? explode( ',', $values ) : $values;
        return !empty( $multi_values ) ? array_map( 'sanitize_text_field', $multi_values ) : array();
    }

    function theme_slug_sanitize_checkbox( $input ){
        return ( ( isset( $input ) && true == $input ) ? true : false );
    }

    function theme_slug_sanitize_radio( $input, $setting ){
        $input = sanitize_key($input);
        $choices = $setting->manager->get_control( $setting->id )->choices;
        return ( array_key_exists( $input, $choices ) ? $input : $setting->default );                
    }

    
        
    $wp_customize->remove_section('colors');
    $wp_customize->remove_section('header_image');
    
    /*Generate Menu Toroflix*/
    $wp_customize->add_panel( 'toroflix_options', array(
        'title' => __( 'Toroflix', 'toroflix' ),
        'priority' => 30,
        'capability' => 'edit_theme_options',
    ));

        $wp_customize->add_section( 'header_option' , array(
            'title'      => __( 'Header Option', 'toroflix' ),
            'panel'      => 'toroflix_options',
            'priority'   => 1,
            'capability' => 'edit_theme_options',
        ));

            #Slider Checkbox
            $wp_customize->add_setting( 'header_type', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'theme_slug_sanitize_checkbox',
                'transport'         => 'refresh'
            ));
            $wp_customize->add_control('header_type', array(
                'label'    => __( 'Enabled Gradient Header', 'toroflix' ),
                'section'  => 'header_option',
                'priority' => 2,
                'type'     => 'checkbox'
            ));
            
       
        #Slider Home
        $wp_customize->add_section( 'slider_section' , array(
            'title'      => __( 'Slider Home', 'toroflix' ),
            'panel'      => 'toroflix_options',
            'priority'   => 1,
            'capability' => 'edit_theme_options',
        ));

            #Slider Checkbox
            $wp_customize->add_setting( 'slider_show', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'theme_slug_sanitize_checkbox',
                'transport'         => 'refresh'
            ));
            $wp_customize->add_control('slider_show', array(
                'label'    => __( 'Enabled Slider', 'toroflix' ),
                'section'  => 'slider_section',
                'priority' => 2,
                'type'     => 'checkbox'
            ));

            #Slider Number
            $wp_customize->add_setting( 'slider_number', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'absint'
            ));
            $wp_customize->add_control('slider_number', array(
                'label'    => __( 'Slider: Number of items', 'toroflix' ),
                'section'  => 'slider_section',
                'priority' => 2,
                'type'     => 'number',
            ));

            #Slider Type
            $wp_customize->add_setting( 'slider_type', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'theme_slug_sanitize_select'
            ));
            $wp_customize->add_control('slider_type', array(
                'label'    => __( 'Slider: Show type post', 'toroflix' ),
                'section'  => 'slider_section',
                'priority' => 2,
                'type'     => 'select',
                'choices'  => array(
                    'movies'        => 'Movies',
                    'series'        => 'Series',
                    'movies_series' => 'Movies and Series',
                )
            ));

            #Slider order
            $wp_customize->add_setting( 'slider_order', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'theme_slug_sanitize_select'
            ));
            $wp_customize->add_control('slider_order', array(
                'label'    => __( 'Slider: Order by', 'toroflix' ),
                'section'  => 'slider_section',
                'priority' => 2,
                'type'     => 'select',
                'choices'  => array(
                    'last'    => 'Last',
                    'popular' => 'Popular (Required WP-PostViews Plugin)',
                    'random'  => 'Random',
                    'sticky'  => 'Sticky'
                )
            ));

        #Pages Toroflix
        $wp_customize->add_section( 'pages_toroflix' , array(
            'title' => __( 'Pages Toroflix', 'toroflix' ),
            'panel' => 'toroflix_options',
            'priority' => 1,
            'capability' => 'edit_theme_options',
        ));
            #Page Movies
            $wp_customize->add_setting( 'page_movie', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'wp_filter_nohtml_kses'
            ));
            $wp_customize->add_control('page_movie', array(
                'label'    => __( 'URL Movies Page', 'toroflix' ),
                'section'  => 'pages_toroflix',
                'priority' => 2,
                'type'     => 'text',
            ));

            #Page Movies
            $wp_customize->add_setting( 'page_serie', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'wp_filter_nohtml_kses'
            ));
            $wp_customize->add_control('page_serie', array(
                'label'    => __( 'URL Series Page', 'toroflix' ),
                'section'  => 'pages_toroflix',
                'priority' => 2,
                'type'     => 'text',
            ));
            
        
        #Block Home
        $wp_customize->add_section( 'block_home' , array(
            'title' => __( 'Block Home', 'toroflix' ),
            'panel' => 'toroflix_options',
            'priority' => 1,
            'capability' => 'edit_theme_options',
        ));

            #Views block
            $wp_customize->add_setting( 'block_home_views', array(
                'type'              => 'option',
                'default'           => array('popular', 'movies', 'series', 'season', 'episode'),
                'sanitize_callback' => 'sanitize_multiple_checkbox',
                'transport'         => 'refresh',
            ) );
            $wp_customize->add_control( new TOROFLIX_multiple_checbox( $wp_customize, 'block_home_views', array(
                'label'       => __( 'Blocks Home', 'toroflix' ),
                'description' => __( 'Select blocks to show in home', 'toroflix' ),
                'section'     => 'block_home',
                'choices'     => array(
                    'popular' => __( 'Most Popular', 'toroflix' ),
                    'movies'  => __( 'Movies', 'toroflix' ),
                    'series'  => __( 'Series', 'toroflix' ),
                    'season'  => __( 'Seasons', 'toroflix' ),
                    'episode' => __( 'Episodes', 'toroflix' ),
                    ),
                'priority' => 2,
            ) ) );

            $wp_customize->add_setting( 'popular_number', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'absint'
            ));
            $wp_customize->add_control('popular_number', array(
                'label'    => __( 'Popular Block: Number of items', 'toroflix' ),
                'section'  => 'block_home',
                'priority' => 2,
                'type'     => 'number',
            ));

            $wp_customize->add_setting( 'movies_number', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'absint'
            ));
            $wp_customize->add_control('movies_number', array(
                'label'    => __( 'Movies Block: Number of items', 'toroflix' ),
                'section'  => 'block_home',
                'priority' => 2,
                'type'     => 'number',
            ));

            $wp_customize->add_setting( 'series_number', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'absint'
            ));
            $wp_customize->add_control('series_number', array(
                'label'    => __( 'Series Block: Number of items', 'toroflix' ),
                'section'  => 'block_home',
                'priority' => 2,
                'type'     => 'number',
            ));

            $wp_customize->add_setting( 'episodes_number', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'absint'
            ));
            $wp_customize->add_control('episodes_number', array(
                'label'    => __( 'Episodes Block: Number of items', 'toroflix' ),
                'section'  => 'block_home',
                'priority' => 2,
                'type'     => 'number',
            ));

            $wp_customize->add_setting( 'seasons_number', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'absint'
            ));
            $wp_customize->add_control('seasons_number', array(
                'label'    => __( 'Seasons Block: Number of items', 'toroflix' ),
                'section'  => 'block_home',
                'priority' => 2,
                'type'     => 'number',
            ));

        #Sidebar
        $wp_customize->add_section( 'sidebar_toroflix' , array(
            'title' => 'Sidebar',
            'panel' => 'toroflix_options',
            'priority' => 1,
            'capability' => 'edit_theme_options',
        ));
            #Slider Type
            $wp_customize->add_setting( 'sidebar_type', array(
                'type'              => 'option',
                'default'           => 'right',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'theme_slug_sanitize_select',
                'transport'         => 'refresh'
            ));
            $wp_customize->add_control('sidebar_type', array(
                'label'    => 'Sidebar Position',
                'section'  => 'sidebar_toroflix',
                'priority' => 2,
                'type'     => 'select',
                'choices'  => array(
                    'right' => 'Right',
                    'left'  => 'Left',
                    'none'  => 'Hide',
                )
            ));


        $wp_customize->add_section( 'poster_option' , array(
            'title'      => __( 'Poster Option', 'toroflix' ),
            'panel'      => 'toroflix_options',
            'priority'   => 1,
            'capability' => 'edit_theme_options',
        ));
            $wp_customize->add_setting( 'poster_option_views', array(
                'type'              => 'option',
                'default'           => array('popular', 'movies', 'series', 'season', 'episode'),
                'sanitize_callback' => 'sanitize_multiple_checkbox',
                'transport'         => 'refresh',
            ) );
            $wp_customize->add_control( new TOROFLIX_multiple_checbox( $wp_customize, 'poster_option_views', array(
                'label'       => __( 'Poster Option View', 'toroflix' ),
                'description' => __( 'Select options to show in poster of series and movies', 'toroflix' ),
                'section'     => 'poster_option',
                'choices'     => array(
                    'year' => 'Year',
                    'lang' => 'Language',
                    'qual' => 'Quality',
                ),
                'priority' => 2,
            ) ) );

        #Lazy Images
        /*$wp_customize->add_section( 'lazy_section' , array(
            'title'      => __( 'Lazy Images', 'toroflix' ),
            'panel'      => 'toroflix_options',
            'priority'   => 1,
            'capability' => 'edit_theme_options',
        ));

            #Slider Checkbox
            $wp_customize->add_setting( 'lazy_show', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'theme_slug_sanitize_checkbox',
                'transport'         => 'refresh'
            ));
            $wp_customize->add_control('slider_show', array(
                'label'    => __( 'Enabled Lazy Images', 'toroflix' ),
                'section'  => 'lazy_section',
                'priority' => 2,
                'type'     => 'checkbox'
            ));*/


        #Footer
        $wp_customize->add_section( 'footer_section' , array(
            'title'      => __( 'Footer', 'toroflix' ),
            'panel'      => 'toroflix_options',
            'priority'   => 1,
            'capability' => 'edit_theme_options',
        ));
            #Footer Text
            $wp_customize->add_setting( 'text_footer', array(
                'type'              => 'option',
                'capability'        => 'edit_theme_options',
                'sanitize_callback' => 'wp_filter_nohtml_kses'
            ));
            $wp_customize->add_control('text_footer', array(
                'label'    => __( 'Text', 'toroflix' ),
                'section'  => 'footer_section',
                'priority' => 2,
                'type'     => 'text',
            ));

            


}
add_action( 'customize_register', 'my_customize_register' );
