<?php
add_action( 'widgets_init', function(){
    register_widget( 'widget_toroflix_footer_info' );
});
class widget_toroflix_footer_info extends WP_Widget {
    #Sets up the widgets name etc
    public function __construct() {
        $widget_ops = array(
            'classname' => 'widget_textfot',
            'description' => 'Show description, image and social link',
        );
        parent::__construct( 'widget_toroflix_footer_info', 'Toroflix: Info', $widget_ops );
    }
    # Display frontend
    public function widget( $argus, $instance ) {
        echo $argus['before_widget']; ?>
        <?php $texts = isset( $instance['texts'] ) ? $instance['texts'] : false; 
        $facebook    = isset( $instance['facebook'] ) ? $instance['facebook'] : false; 
        $twitter     = isset( $instance['twitter'] ) ? $instance['twitter'] : false; 
        $instagram   = isset( $instance['instagram'] ) ? $instance['instagram'] : false; 
        $youtube     = isset( $instance['youtube'] ) ? $instance['youtube'] : false;  ?>
        <figure class="Logo"><img src="<?php echo TOROFLIX_DIR_URI; ?>public/img/toroflix-logo.svg" alt="ToroFlix"></figure>
        <?php if($texts){ ?>
        <p><?php echo $texts; ?></p><?php } ?>
        <ul class="SocialList">
            <?php if($facebook) 
                echo '<li><a target="_blank" href="'.$facebook.'" class="fa-facebook"></a></li>'; ?>
            <?php if($twitter) 
                echo '<li><a target="_blank" href="'.$twitter.'" class="fa-twitter"></a></li>'; ?>
            <?php if($instagram) 
                echo '<li><a target="_blank" href="'.$instagram.'" class="fa-instagram"></a></li>'; ?>
            <?php if($youtube) 
                echo '<li><a target="_blank" href="'.$youtube.'" class="fa-youtube"></a></li>'; ?>
        </ul>
        <?php echo $argus['after_widget'];
    }
    #Parameters Form of Widget
    public function form( $instance ) {
        $title     = ! empty( $instance['title'] ) ? $instance['title'] : __( '', 'toroflix' );
        $texts     = isset( $instance['texts'] ) ? $instance['texts'] : '';
        $facebook  = ! empty( $instance['facebook'] ) ? $instance['facebook'] : false;
        $twitter   = ! empty( $instance['twitter'] ) ? $instance['twitter'] : false;
        $instagram = ! empty( $instance['instagram'] ) ? $instance['instagram'] : false;
        $youtube   = ! empty( $instance['youtube'] ) ? $instance['youtube'] : false;
        ?>
            <p>
            <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'toroflix' ); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
            </p>
            <p>
                <label for="<?php echo $this->get_field_id( 'texts' ); ?>"><?php _e( 'Description:', 'toroflix' ); ?></label>
                <textarea placeholder="Description" style="width: 100%;" name="<?php echo $this->get_field_name( 'texts' ); ?>" id="" cols="30" rows="10"><?php echo $texts; ?></textarea>
            </p>
            <p>
                <label for="<?php echo $this->get_field_id( 'facebook' ); ?>">Facebook:</label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'facebook' ); ?>" name="<?php echo $this->get_field_name( 'facebook' ); ?>" type="text" value="<?php echo esc_attr( $facebook ); ?>">
            </p>
            <p>
                <label for="<?php echo $this->get_field_id( 'twitter' ); ?>">Twitter:</label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'twitter' ); ?>" name="<?php echo $this->get_field_name( 'twitter' ); ?>" type="text" value="<?php echo esc_attr( $twitter ); ?>">
            </p>
            <p>
                <label for="<?php echo $this->get_field_id( 'instagram' ); ?>">Instagram:</label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'instagram' ); ?>" name="<?php echo $this->get_field_name( 'instagram' ); ?>" type="text" value="<?php echo esc_attr( $instagram ); ?>">
            </p>
            <p>
                <label for="<?php echo $this->get_field_id( 'youtube' ); ?>">Youtube:</label>
                <input class="widefat" id="<?php echo $this->get_field_id( 'youtube' ); ?>" name="<?php echo $this->get_field_name( 'youtube' ); ?>" type="text" value="<?php echo esc_attr( $youtube ); ?>">
            </p>
        <?php
    }
    #Save Data
    public function update( $new_instance, $old_instance ) {
        // processes widget options to be saved
        foreach( $new_instance as $key => $value )
        {
            $updated_instance[$key] = sanitize_text_field($value);
        }
        return $updated_instance;
    }
}