<?php 
add_action( 'widgets_init', function(){
    register_widget( 'toroflix_genres_widget' );
});

class toroflix_genres_widget extends WP_Widget {

    #Sets up the widgets name etc

    public function __construct() {
        $widget_ops = array(
            'classname' => 'widget_categories',
            'description' => __( 'Show list of all categories', 'toroflix' ),
        );
        parent::__construct( 'toroflix_genres_widget', 'Toroflix: Genres', $widget_ops );
    }


    # Display frontend

    public function widget( $argus, $instance ) {
 
        echo $argus['before_widget'];
        if ( ! empty( $instance['title'] ) ) {
            echo $argus['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $argus['after_title'];
        } ?>

		<ul>
            
            <?php
            $categories = get_categories( array(
                'orderby' => 'name',
                'order'   => 'ASC'
            ) );
             
            foreach( $categories as $category ) { 
                if($categories){ ?>
                
                <li><a href="<?php echo esc_url( get_category_link( $category->term_id ) ); ?>"><?php echo esc_html( $category->name );  ?></a> <?php echo $category->count;  ?></li>
               
                <?php }
            } ?>   
        </ul>
        
        <?php echo $argus['after_widget'];
    }


    #Parameters Form of Widget
    public function form( $instance ) {
        $title = ! empty( $instance['title'] ) ? $instance['title'] : __( '', 'toroflix' );
        ?>
            <p>
            <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'toroflix' ); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
            </p>
        <?php
    }


    #Save Data
    public function update( $new_instance, $old_instance ) {
        // processes widget options to be saved
        foreach( $new_instance as $key => $value )
        {
            $updated_instance[$key] = sanitize_text_field($value);
        }

        return $updated_instance;
    }
}