<?php 
add_action( 'widgets_init', function(){
    register_widget( 'navigation_widget_toroflix' );
});

class navigation_widget_toroflix extends WP_Widget {

    #Sets up the widgets name etc

    public function __construct() {
        $widget_ops = array(
            'classname' => 'widget_nav_menu',
            'description' => 'show navigation',
        );
        parent::__construct( 'navigation_widget_toroflix', 'Toroflix: Navigation', $widget_ops );
    }


    # Display frontend

    public function widget( $argus, $instance ) {
 
        echo $argus['before_widget'];
        if ( ! empty( $instance['title'] ) ) {
            echo $argus['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $argus['after_title'];
        } 

        $menu = isset( $instance['menu'] ) ? $instance['menu'] : false; ?>

        <div class="menu-sidebar-container">
            <?php 
                wp_nav_menu(
                    array(
                        'menu'       => $menu,
                        'container'  =>  false,
                        'items_wrap' =>  '<ul id="menu-sidebar" class="menu">%3$s</ul>',
                    )
                );
                
            ?>
            
        </div>
        <?php echo $argus['after_widget'];
    }


    #Parameters Form of Widget
    public function form( $instance ) {
        $title = ! empty( $instance['title'] ) ? $instance['title'] : __( '', 'toroflix' );
        $menu = isset( $instance['menu'] ) ? $instance['menu'] : false;
        ?>
            <p>
            <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:', 'toroflix' ); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
            </p>

            <p>
                <label for="<?php echo $this->get_field_id('menu'); ?>"><?php _e('Select menu', 'toroflix'); ?></label>
                <select id="<?php echo $this->get_field_id('menu'); ?>" name="<?php echo $this->get_field_name('menu'); ?>">
                    <?php $menus = get_terms('nav_menu');
                    if($menus){
                        foreach($menus as $key => $men){ ?>
                            <option<?php selected( $menu, $men->slug ); ?> value="<?php echo $men->slug; ?>"><?php echo $men->name; ?></option>
                        <?php }
                    } ?>
                </select>                
            </p>
        <?php
    }


    #Save Data
    public function update( $new_instance, $old_instance ) {
        // processes widget options to be saved
        foreach( $new_instance as $key => $value )
        {
            $updated_instance[$key] = sanitize_text_field($value);
        }

        return $updated_instance;
    }
}
